org.eclipse.viatra.query.runtime.localsearch.operations.extend

## Class ExtendToEStructuralFeatureSource

- java.lang.Object
- - org.eclipse.viatra.query.runtime.localsearch.operations.extend.ExtendToEStructuralFeatureSource

- All Implemented Interfaces:
    IIteratingSearchOperation, ISearchOperation

      public class ExtendToEStructuralFeatureSource
      extends java.lang.Object
      implements IIteratingSearchOperation

  Iterates over all sources of `EStructuralFeature` using an `VIATRA Base indexer`. It is assumed that the indexer is initialized for the selected `EStructuralFeature`.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface org.eclipse.viatra.query.runtime.localsearch.operations.ISearchOperation

      `ISearchOperation.ISearchOperationExecutor`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ExtendToEStructuralFeatureSource(int sourcePosition, int targetPosition, org.eclipse.emf.ecore.EStructuralFeature feature, TupleMask mask)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `ISearchOperation.ISearchOperationExecutor` | `createExecutor()` Initializes a new operation executor for the given operation.
    `org.eclipse.emf.ecore.EStructuralFeature` | `getFeature()`
    `IInputKey` | `getIteratedInputKey()` Get the `IInputKey` which instances this operation iterates upon.
    `java.util.List<java.lang.Integer>` | `getVariablePositions()`
    `java.lang.String` | `toString()`
    `java.lang.String` | `toString(java.util.function.Function<java.lang.Integer,java.lang.String> variableMapping)` Creates a string representation of the search operation by replacing the variable numbers according to the parameter function.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### ExtendToEStructuralFeatureSource

          public ExtendToEStructuralFeatureSource(int sourcePosition,
                                                  int targetPosition,
                                                  org.eclipse.emf.ecore.EStructuralFeature feature,
                                                  TupleMask mask)

      Since:
        1.7

  - ### Method Detail

    - #### getFeature

          public org.eclipse.emf.ecore.EStructuralFeature getFeature()

    - #### createExecutor

          public ISearchOperation.ISearchOperationExecutor createExecutor()

      Description copied from interface: `ISearchOperation`
      Initializes a new operation executor for the given operation. Repeated calls must return different executor instances.
      Specified by:
        `createExecutor` in interface `ISearchOperation`

    - #### toString

          public java.lang.String toString()

      Overrides:
        `toString` in class `java.lang.Object`

    - #### toString

          public java.lang.String toString(java.util.function.Function<java.lang.Integer,java.lang.String> variableMapping)

      Description copied from interface: `ISearchOperation`
      Creates a string representation of the search operation by replacing the variable numbers according to the parameter function. It is expected that the provided function does return a non-null value for each variable index that is returned by `ISearchOperation.getVariablePositions()`; otherwise a `NullPointerException` will be thrown during the calculation of the string.
      Specified by:
        `toString` in interface `ISearchOperation`

    - #### getVariablePositions

          public java.util.List<java.lang.Integer> getVariablePositions()

      Specified by:
        `getVariablePositions` in interface `ISearchOperation`
      Returns:
        the ordered list of the variable numbers that are affected by the search operation

    - #### getIteratedInputKey

          public IInputKey getIteratedInputKey()

      Description copied from interface: `IIteratingSearchOperation`
      Get the `IInputKey` which instances this operation iterates upon.
      Specified by:
        `getIteratedInputKey` in interface `IIteratingSearchOperation`
      Since:
        1.4